import ftcomputing.robo.*;
/**
 * Industry Robots II : Sulenroboter betrieben ber das Robo Interface
 * 
 * @author Ulrich Mller 
 * @version 18.03.10

 */
public class RobIR2 {
    private       FishFace ft;
    private int[] actPos   = new int[3];
    private int   gripOpen;
    
    static final int   GripClosed = 26;
    static final int[] RobMot     = new int[]{1, 2, 3};
    static final int   GripMot    = 4;
    
    public RobIR2() {
        ft = new FishFace();
    }
    public void start() {
        ft.openInterface(0, 0);
        for(int pos : actPos) pos = 0;
        gripOpen = 0;
    }
    public void ende() {
        ft.closeInterface();
    }
    
    /**
     * Simultanes Anfahren der Home-Position des ganzen Roboters
     */
    public void moveHome() {
        System.out.println("Home simultan");
        for(int mot : RobMot) 
            ft.setMotor(mot, Dir.Left, Speed.Full, 9999);
        ft.waitForMotors(0, RobMot);
        gripper(0);
        for(int pos : actPos) pos = 0;
    }
        
    /**
     * Simultanes Anfahren einer vorgegebenen Position
     */
    public void moveTo(int... pos) {
       System.out.print("Robot fhrt auf neue Position");
       for(int p : pos) System.out.print(" - " + p);
       for(int i = 0; i < actPos.length; i++) {
           if(pos[i] < actPos[i]) 
               ft.setMotor(RobMot[i], Dir.Left, Speed.Full, actPos[i] - pos[i]);
           else if(pos[i] > actPos[i]) 
               ft.setMotor(RobMot[i], Dir.Right, Speed.Full, pos[i] - actPos[i]);
        }
        ft.waitForMotors(0, RobMot);
        for(int i = 0; i < actPos.length; i++) actPos[i] = pos[i];
    }
    
    /**
     * Bettigen Greifer
     */
    public void gripper(int open) {
        if(open == 0) { 
          System.out.println(" : Greifer ffnet");
          ft.setMotor(GripMot, Dir.Left, Speed.Full, 9999);
          ft.waitForMotors(0, GripMot);
          gripOpen = 0;
        }
        else if (gripOpen == 0) { 
          System.out.println(" : Greifer schliet");
          ft.setMotor(GripMot, Dir.Right, Speed.Full, GripClosed);
          ft.waitForMotors(0, GripMot);
          gripOpen = GripClosed;
        }
    }
}
