import ftcomputing.robo.*;
/**
 * Einfhrung in die Programmierung der Industry Robot mit ftcomputing.robo.jar : FishFace
 * 
 * Sulenrobot nach Industry Robot II mit der dort angegebenen Interface-Belegung
 * Sule M1, Endtaster I1, Impulstaster I2, 
 * Arm waagerecht M2, I3, I4, Arm senkrecht M3, I5, I6
 * Greifer M4, I7, I8, alternative Lampe
 * Die Robotkomponenten mssen bei Linkslauf auf den zugehrenden Endtaster drehen.
 * 
 * @author Ulrich Mller 
 * @version 14.03.10
 */
public class RobTut {
    private FishFace ft;
    private int[] actPos = new int[4];
    /**
     * Konstruktor mit OpenInterface an erstem Robo Interface an USB
     */
    public RobTut() {
        ft = new FishFace();
        ft.openInterface(0, 0);
    }

    /**
     * Sule mit Motor an M1 luft links bis Endtaster an I1
     */
    public void goHome() {
        System.out.println("Motor M1 Home, wartet auf I1");
        ft.setMotor(Mot.M1, Dir.Left);
        ft.waitForInput(Inp.I1);
        ft.setMotor(Mot.M1, Dir.Off);
        System.out.println("--- Zu Hause ---");
    }
    
    /**
     * Fahren Sule um Anzahl Impulse nach rechts
     */
    public void goRight(int Inc) {
        System.out.println("Sule dreht rechts um : " + Inc);
        ft.setMotor(Mot.M1, Dir.Right, Speed.Full, Inc);
        ft.waitForMotors(0, Mot.M1);
        System.out.println("--- Sule angekommen ---");
    }   
}
