import ftcomputing.robo.*;
/**
 * Turm von Hanoi : Lsung mit Robo Interface und FishFace
 * Variante Experimental : Eine Klasse mit public Methoden
 *                         Instanzierung erforderlich
 * 
 * @author Ulrich Mller 
 * @version Java 6 - BlueJ 14.04.10
 */
public class HanoiTower extends FishFace {
    public final int mSaule    = Mot.M1;
    public final int mArm      = Mot.M2;
    public final int iArmOben  = Inp.I3;
    public final int iArmUnten = Inp.I4;
    public final int mGreifer  = Mot.M3;
    public int robPos;
    
    public HanoiTower() {
        openInterface(0, 0);
        System.out.println("HanoiTower USB-Verbindung OK");
    }
    public void action() {
        System.out.println("Fhrt auf Grundstellung");
        grundstellung();
        System.out.println("Bei der Arbeit");
        hanoi(3, 5, 45, 75);
        ende();
    }
    public void hanoi(int n, int pAnf, int pMit, int pEnd) {
        if(n == 1) {
            ziehe(pAnf, pEnd);
        } else {
            hanoi(n-1, pAnf, pEnd, pMit);
            ziehe(pAnf, pEnd);
            hanoi(n-1, pMit, pAnf, pEnd);
        }
    }
        
    public void ende() {
        closeInterface();
        System.out.println("USB-Verbindung beendet");
    }
    public void grundstellung() {
        setMotor(mGreifer, Dir.Off);
        armHeben();
        robPos = 9999;
        sauleNach(0);
        System.out.println("Auf Grundstellung");
    }
    public void ziehe(int von, int nach) {
        sauleNach(von);
        armSenken();
        setMotor(mGreifer, Dir.On);
        armHeben();
        sauleNach(nach);
        armSenken();
        setMotor(mGreifer, Dir.Off);
        armHeben();
    }
    public void sauleNach(int zielPos) {
        if(robPos < zielPos) 
          setMotor(mSaule, Dir.Right, Speed.Full, zielPos-robPos);
        else 
           setMotor(mSaule, Dir.Left, Speed.Full, robPos-zielPos);
        waitForMotors(0, mSaule);
        robPos = zielPos;
    }
    public void armSenken() {
        setMotor(mArm, Dir.Left);
        waitForInput(iArmUnten);
        setMotor(mArm, Dir.Off);
    }
    public void armHeben() {
        setMotor(mArm, Dir.Right);
        waitForInput(iArmOben);
        setMotor(mArm, Dir.Off);
    }
}
