import ftcomputing.robo.*;
/**
 * Turm von Hanoi : Lsung mit Robo Interface und FishFace
 * Variante Main  : Start mit void main() ohne voherige Instanzierung
 * 
 * @author Ulrich Mller 
 * @version Java 6 - BlueJ 14.04.10
 */
public class HanoiTowerMain {
    HanoiRobot hr;
    public static void main() {
        HanoiTowerMain ht = new HanoiTowerMain();
        ht.Action();
    }
    private void Action() {
        hr = new HanoiRobot();
        System.out.println("HanoiTower wird gestartet");
        hr.openInterface(0, 0);
        System.out.println("Fhrt auf Grundstellung");
        hr.grundstellung();
        System.out.println("Bei der Arbeit");
        hanoi(3, 5, 45, 75);
        System.out.println("--- FINIS ---");
        hr.closeInterface();
    }
    private void hanoi(int n, int pAnf, int pMit, int pEnd) {
        if(n == 1) {
            hr.ziehe(pAnf, pEnd);
        } else {
            hanoi(n-1, pAnf, pEnd, pMit);
            hr.ziehe(pAnf, pEnd);
            hanoi(n-1, pMit, pAnf, pEnd);
        }
    }
    private class HanoiRobot extends FishFace {
        private final int mSaule    = Mot.M1;
        private final int mArm      = Mot.M2;
        private final int iArmOben  = Inp.I3;
        private final int iArmUnten = Inp.I4;
        private final int mGreifer  = Mot.M3;
        private int robPos;
        
        public void grundstellung() {
            setMotor(mGreifer, Dir.Off);
            armHeben();
            robPos = 9999;
            sauleNach(0);
        }
        public void ziehe(int von, int nach) {
            sauleNach(von);
            armSenken();
            setMotor(mGreifer, Dir.On);
            armHeben();
            sauleNach(nach);
            armSenken();
            setMotor(mGreifer, Dir.Off);
            armHeben();
        }
        private void sauleNach(int zielPos) {
            if(robPos < zielPos) 
              setMotor(mSaule, Dir.Right, Speed.Full, zielPos-robPos);
            else 
              setMotor(mSaule, Dir.Left, Speed.Full, robPos-zielPos);
            waitForMotors(0, mSaule);
            robPos = zielPos;
        }
        private void armSenken() {
            setMotor(mArm, Dir.Left);
            waitForInput(iArmUnten);
            setMotor(mArm, Dir.Off);
        }
        private void armHeben() {
            setMotor(mArm, Dir.Right);
            waitForInput(iArmOben);
            setMotor(mArm, Dir.Off);
        }
    }
}
