import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import ftcomputing.robo.*;

/**
 * Betrieb eines Motor am Robo Interface ber eine Swing-Klasse
 * 
 * @author Ulrich Mller
 * @version 01.04.10
 */
public class SwingMot extends JFrame implements ActionListener {
    private JLabel lblStatus;
    private JButton cmdLinks;
    private JButton cmdAus;
    private JButton cmdRechts;
    
    private FishFace ft;

    public SwingMot() {
        setTitle("Robo Interface und Swing");
        setLayout(new GridLayout(4,1));
        
        lblStatus = new JLabel("Motor an M3", JLabel.CENTER);
        add(lblStatus);
        cmdLinks = new JButton("Links");
        cmdLinks.addActionListener(this);
        add(cmdLinks);
        cmdAus = new JButton("Aus");
        cmdAus.addActionListener(this);
        add(cmdAus);
        cmdRechts = new JButton("Rechts");
        cmdRechts.addActionListener(this);        
        add(cmdRechts);
        
        ft = new FishFace();
        ft.openInterface(0, 0);
    }
    public void actionPerformed(ActionEvent e) {
        Object cmd = e.getSource();
        if(cmd == cmdLinks) {
            ft.setMotor(Mot.M3, Dir.Left);
            lblStatus.setText("M3 : Links");
        }
        else if(cmd == cmdRechts) {
            ft.setMotor(Mot.M3, Dir.Right);
            lblStatus.setText("M3 : Rechts");
        }
        else {
            ft.setMotor(Mot.M3, Dir.Off);
            lblStatus.setText("M3 : Aus");
        }
    }
}
